#ifndef WLPDSTM_TIMESTAMP_H_
#define WLPDSTM_TIMESTAMP_H_

#include "../constants.h"
#include "atomic.h"
#include "word.h"

namespace wlpdstm {

	class GlobalTimestamp {
		public:
			GlobalTimestamp() : ts(MINIMUM_TS + 1) {  }

			Word readCurrentTs() const {
				return ts;
			}

			Word readCurrentTsAcquire() const {
				return (unsigned)atomic_load_acquire(&ts);
			}

			Word getNextTsFull() {
				return fetch_and_inc_full(&ts);
			}

			Word getNextTsAcquire() {
				return fetch_and_inc_acquire(&ts);
			}

			Word getNextTs() {
				return fetch_and_inc_no_barrier(&ts);
			}

			void restart() {
				ts = MINIMUM_TS + 1;
			}

		private:
			Word ts;

			char padding[CACHE_LINE_SIZE_BYTES - sizeof(Word)];
	};
}

#endif // WLPDSTM_TIMESTAMP_H_
